--local msg = "Creas: [Copper Bar]"
--print("CHAT_MSG_TRADESKILLS fired: " .. msg);
--local crafted = string.match(msg, "Creas: %[Copper Bar%]");
--print(crafted)

--strtosearchx = string.find(string.lower("Antonidas"),"antonidas");
--print(strtosearchx);

	--trying to do the color formatted whisper using strings
--NPC variables
--nAla = "Aladriaa"
--print(string.format("%s %s %s", "|cffffcc00[", nAla, "] whispers:|r"));
--But I"m already doing something that works with "ChatWhisper" below...
--print(string.format("%s%s%s%s%s", "|cffffcc00[", nAla, "] whispers: A'hoy thar! I be ", nAla, "... I'm the lass who'll be steering this ship. Savvy? The Great Aspect Alexstraza has seen fit to trust ye' swabs to handle a grave peril - ye' be our last hope.\nFirst, ye'll need to understand what those bilge-sucking rapscallions have been up to. That I can tell ye in a vision I'll be channelin' through yer ring...|r"));

-- #######################################################
-- Debug functions & utilities
-- #######################################################

--was starting to work on a function to make adding/removing chat channels contingent on what was already joined
--local nm1, id1, nm2, id2, nm3, ch3 = GetChatWindowChannels()

function trace(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end

function returnNiceBoolean(arg)
	if (arg == true) then
		return true;
	else
		return false;
	end
end

function cleanslashes(msg)
	--get rid of doubled slashes inserted by the Blizzard chat window
	local cleanedstring = string.gsub(msg, "\\\\", "\\")
	return cleanedstring
end

--print(cleanslashes("\\\\"))

function MtableDelete(tbl1)
   for k,v in pairs(tbl1) do tbl1[k]=nil end
end

function MtableCopy(tbl1)
   local tempTbl = {}
   for k,v in pairs(tbl1) do
     tempTbl[k] = v
   end
   return tempTbl
end

function MakeMovable(frame)
	frame:SetMovable(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
end

--Is this still being used? Is this how MalVars.listeners is set to 1? What about SCchiefBaddie? Is it still used?
function setupGuildVariables()
	local mauvies1 = "Mauve Marauders"
	local mauvies2 = "Mauve Maraud\195\171rs"
	local shadies = "Shadow Council"
	local guildie, guildiestatus, guildierankindex = GetGuildInfo("player")
	if ((tostring(guildie) == mauvies1) or (tostring(guildie) == mauvies2) or (tostring(guildie) == shadies)) then
		MalVars.listeners = 1;
	end
	if ((UnitName("Player") == "Izuna") or (UnitName("Player") == "Izunai") or (UnitName("Player") == "Vaas")) then
		SCchiefBaddie = 1
	end
end

function SCachieve(title, descr)
	--this function is triggered locally when an event fires (or a researcher button message is received)
	--so from here, all action is local (not sending another addon message)
	--trace("got a call to launch the achievement frame");
	--Add sound here
	PlaySound("LFG_Rewards");
	--Also echo to chat -- may want to echo one line per party member instead, have to do an enumeration here
	if descr and (descr ~= nil) then
		--this means there's a description and so it's an achievement
		print("|cffff8000" .. descr .. "\nSu grupo se ha ganado la Haza\195\177a Picaroon |r|cffffff00[" .. title .. "]|cffff8000!|r");
	else
		--this means there's no description and so it's probably a promotion
		print("|cffff8000\194\161Su grupo ha sido |r|cffffff00[Ascendido]|cffff8000!|r");
	end
	AchieveFrameName:SetText(title)
	AchieveFrame:Show()
	--AchieveFrame.animIn:Play()
	AchieveFrameGlow.animIn:Play()
	AchieveFrameShine.animIn:Play()
	AchieveFrame.waitAndAnimOut:Play()
end

function ChatWhisper(who, whisptext)
	--trace("launched ChatWhisper with parameters " .. who .. " ; " .. whisptext);
	print("|cffffcc00" .. who .. " susurra: " .. whisptext .. "|r");
end

function ChatWhisper2(who1, whisptext1, who2, whisptext2)
	--uses a source of the whisper, some text, a name (same or different), and more text
	--trace("launched ChatWhisper with parameters " .. who1 .. " ; " .. whisptext1 .. " ; " .. who2 .. " ; " .. whisptext2);
	print("|cffffcc00" .. who1 .. " susurra: " .. whisptext1 .. who2 .. whisptext2 .. "|r");
end

function AddToOverhead(screentext)
	MarauderScreenText:SetAlpha("1");
	Marauder:Show();
	MarauderScreenText:SetText(screentext);
	MarauderScreenText.anim01:Play();
end;

function AddToOverheadQuick(screentext)
	MarauderScreenText:SetAlpha("1");
	Marauder:Show();
	MarauderScreenText:SetText(screentext);
	MarauderScreenText.anim02:Play();
end;

function AddToOverheadLong(screentext)
	MarauderScreenText:SetAlpha("1");
	Marauder:Show();
	MarauderScreenText:SetText(screentext);
	MarauderScreenText.anim03:Play();
end;

function AddToOverheadDelayed(screentext)
	MarauderScreenText:SetAlpha("0"); -- fading in after 5 second delay
	Marauder:Show();
	MarauderScreenText:SetText(screentext);
	MarauderScreenText.anim04:Play();
end;

--function to capture position of the avatar and send to off-faction log
function positionReport()
	if (MalVars.listeners == 1) then
		--the following will happen inside a timed position capture function
		--print("if any other guild members were on, I'd send a position report");
		local unitX, unitY = GetPlayerMapPosition("player")
		--local ew = (math.floor(10000 * unitX))/100
		--local ns = (math.floor(10000 * unitY))/100
		--print("LOC " .. GetSubZoneText() .. ", " .. tostring(unitX) .. ", " .. tostring(unitY))
		--trace("sending position: " .. unitX .. ", " .. unitY)
		sendToShortGuy(tostring(unitX) .. ":" .. tostring(unitY), "pos");
	end
end

--function that will be called to send an event to the non-party researcher logs
function sendToShortGuy(msgToSend, msgtype)
	--print("called the sendToShortGuy function with parameters: " .. msgToSend .. ", " .. msgtype);
	if (msgtype == "pos") then
		--SendAddonMessage("SCSHORTPOS", msgToSend, "GUILD");
	elseif (msgtype == "emo") then
		SendAddonMessage("SCSHORTEMO", msgToSend, "WHISPER", OffresearcherName);
	elseif (msgtype == "custemo") then
		SendAddonMessage("SCSHORTCUSTEMO", msgToSend, "WHISPER", OffresearcherName);
	elseif (msgtype == "yell") then
		SendAddonMessage("SCSHORTYELL", msgToSend, "WHISPER", OffresearcherName);
	end
end

--the non-party researcher has received a message to log; this actually sends it there
function sendToOffFacResearcherLogger(output, msgType, target)
	--print("called the sendToOffFacResearcherLogger function with parameters: " .. output .. ", " .. msgType .. ", " .. target)
	if msgType == "chatAndEvents" then
		SendAddonMessage("SCoff", output, "WHISPER", target)
		--print("sending addon message with prefix OffFaclog, output: " .. output .. ", WHISPER, target: " .. target)
	end
end

function sendToResearcherLogger(output)
	--trace("function sendToResearcherLogger received a message, sending AddonMessage to prefix 'log' over PARTY")
	SendAddonMessage("log", output, "PARTY");
end

--used to send the log message to the ResearcherLogger
function sendWhisperToResearcherLogger(output)
	--trace("function sendWhisperToResearcherLogger received a message, sending AddonMessage to prefix 'log' over WHISPER to " .. UnitName("Player"))
	SendAddonMessage("log", output, "WHISPER", UnitName("player"));
end

function popVote()
	MalVars.checkpoint = 200;
	--Display the voting graphic
	MarauderTabs:Show();
	MaleanteTab1:Show();
	MaleanteTab2:Show();
	MaleanteTab3:Show();
	MaleanteTab4:Show();
	MaleanteTab5:Show();
	MaleanteTab6:Show();
	MaleanteTab7:Show();
	MaleanteTab8:Show();
	MaleanteTab9:Show();
	MaleanteTab10:Show();
	MaleanteTab11:Show();
	MaleanteTab12:Show();
end;

function clearVote()
	--Hide the voting graphic, used for testing mostly?
	MarauderTabs:Hide();
	MaleanteTab1:Hide();
	MaleanteTab2:Hide();
	MaleanteTab3:Hide();
	MaleanteTab4:Hide();
	MaleanteTab5:Hide();
	MaleanteTab6:Hide();
	MaleanteTab7:Hide();
	MaleanteTab8:Hide();
	MaleanteTab9:Hide();
	MaleanteTab10:Hide();
	MaleanteTab11:Hide();
	MaleanteTab12:Hide();
end;


--function foodOrDrinkText (newItemNameInBag)
	--trace("received a query for " .. newItemNameInBag);
	--for i = 1, #vittles do
		--if ((newItemNameInBag == vittles[i].vName) and (MalVars.checkpoint == 24)) then
			--print("(foodOrDrinkText) Got a hit on " .. vittles[i].vName .. ": it's a " .. vittles[i].vType)
			--SendAddonMessage("SCv1", vittles[i].vType, "PARTY");
		--end;
	--end
--end


function closeEnough(thresh, locX, locY)
	--trace("Values passed: " .. thresh .. ", " .. locX .. ", " .. locY);
	-- compare player location with target location passed in, if distance between them is at or lower than a specified threshold then TRUE
	local meX, meY = GetPlayerMapPosition("player");
	--trace("meX = " .. meX .. ", meY = " .. meY);
	local distToLoc = math.pow((math.pow((locX - meX), 2) + math.pow((locY - meY), 2)), 0.5);
	--trace("distToLoc = " .. distToLoc .. ", threshold = " .. thresh);
	if (distToLoc <= thresh) then
		return 1;
	else
		return 0;
	end;
end;



function traceboolean(arg)
	if (arg == true) then
		trace(true);
	else
		trace(false);
	end
end


function round(n, precision)
  local m = 10^(precision or 0)
  return floor(m*n + 0.5)/m
end


function scPlayTickSound()
	PlaySound("igMainMenuOptionCheckBoxOn")
end

function SCclueEntry()
	local newclue = EnterClue.input:GetText();
	local cluetosend = string.lower(newclue);
	print("Set code to: " .. cluetosend);
	SendAddonMessage("SRCLUE", cluetosend, "PARTY");
	EnterClue:Hide();
end

function closeSCclueEntry()
	EnterClue:Hide()
	trace("Cancelled entry of code");
end

function SCnameEntry()
	local nametosend = EnterName.input:GetText();
	print("Set group name to: " .. nametosend);
	SendAddonMessage("SRNAME", nametosend, "PARTY");
	EnterName:Hide();
end

function closeCheckpointReset()
	EnterName:Hide()
	trace("Cancelled entry of group name");
end


function sendCheckpointReset()
	local newnum = ResetCheckpoint.input:GetText();
	sendReset(newnum)
	ResetCheckpoint:Hide()
end

function closeCheckpointReset()
	ResetCheckpoint:Hide()
	trace("Cancelled reset of MalVars.checkpoint");
end

function sendReset(num)
	--tell the whole party to reset their MalVars.checkpoint variable to the number passed
	--everyone will run setMalVars.checkpoint with that number
	SendAddonMessage("SReset", num, "PARTY")
	trace("Sent command to reset MalVars.checkpoint to " .. num);
end

function malTranslate(zone)
	--pass the zone name to translate, which will only happen if the environment is Spanish
	--translate the zone name into English and pass that back for logging
	if zone == MalVars.Zones.crystalsongforest then
		return MalVars.Zones.ENcrystalsongforest;
	elseif zone == MalVars.Zones.violetstand then
		return MalVars.Zones.ENvioletstand;
	elseif zone == MalVars.Zones.violetportal then
		return MalVars.Zones.ENvioletportal;
	elseif zone == MalVars.Zones.runeweaversquare then
		return MalVars.Zones.ENruneweaversquare;
	elseif zone == MalVars.Zones.legerdemainlounge then
		return MalVars.Zones.ENlegerdemainlounge;
	elseif zone == MalVars.Zones.wonderworks then
		return MalVars.Zones.ENwonderworks;
	elseif zone == MalVars.Zones.threadsoffate then
		return MalVars.Zones.ENthreadsoffate;
	elseif zone == MalVars.Zones.magescommerceexchange then
		return MalVars.Zones.ENmagescommerceexchange;
	elseif zone == MalVars.Zones.forgeoffate then
		return MalVars.Zones.ENforgeoffate;
	elseif zone == MalVars.Zones.allthatglitters then
		return MalVars.Zones.ENallthatglitters;
	elseif zone == MalVars.Zones.violetcitadel then
		return MalVars.Zones.ENvioletcitadel;
	elseif zone == MalVars.Zones.purpleparlor then
		return MalVars.Zones.ENpurpleparlor;
	elseif zone == MalVars.Zones.underbelly then
		return MalVars.Zones.ENunderbelly;
	elseif zone == MalVars.Zones.circleofwills then
		return MalVars.Zones.ENcircleofwills;
	elseif zone == MalVars.Zones.blackmarket then
		return MalVars.Zones.ENblackmarket;
	elseif zone == MalVars.Zones.dalaran then
		return MalVars.Zones.ENdalaran;
	elseif zone == MalVars.Zones.forlornwoods then
		return MalVars.Zones.ENforlornwoods;
	elseif zone == MalVars.Zones.twilightrivulet then
		return MalVars.Zones.ENtwilightrivulet;
	elseif zone == MalVars.Zones.cantripsandcrows then
		return MalVars.Zones.ENcantripsandcrows;
	else
		return "zoneTranslate error";
	end
end

function setCheckpoint(chkpt)
	--Used to set the variable MalVars.checkpoint to a value for all players, and match MalVars.currQuest and MarauderTracker display
	--Try to set other variables too?

	if chkpt >= 0 then
		--Use INIT button for this, since it's resetting everything... but if you must...
		MarauderRing:Hide();
		MarauderBook:Hide();
		Marauder:Hide();
		MarauderTracker:Hide();
		MarauderRes:Hide();
	end

	if chkpt >= 10 then
		--Same as state after INIT button
		WatchFrame:Hide(); --Hide the Blizzard Quest Tracker
		MultiBarLeft:Hide(); --Hide the Blizzard Right-screen Action Bar 1
		MultiBarRight:Hide(); --Hide the Blizzard Right-screen Action Bar 2
		LeaveChannelByName(MalVars.Channels.trade);
		LeaveChannelByName(MalVars.Channels.lfg);
		LeaveChannelByName(MalVars.Channels.general);
		LeaveChannelByName(MalVars.Channels.localdefense);
		MalVars.rune, MalVars.viol, MalVars.und = 0, 0, 0;
		MalVars.pName1, MalVars.pName2, MalVars.pName3, MalVars.pName4 = "", "", "", "";			-- Party member names (string)
		MalVars.checkpoint = 10;													-- Logic flow variable (number)
		MalVars.currQuest = "q0a";												-- For display in Quest Log (string)
		MalVars.whoClue, MalVars.whatClue = nil, nil; 									-- For display in Quest Log (string)
		MalVars.merch1Tlk, MalVars.merch2Tlk, MalVars.merch3Tlk = 0, 0, 0;		-- Whether each merchant has been talked to (0 or 1)
		MalVars.merchantClues = 0; 											-- How many group has achieved (number)
		MalVars.merchantTalkCount = 0; 										-- How many this player has spoken to (number)
		MalVars.merchClueTxt1, MalVars.merchClueTxt2 = nil, nil; 			-- For display in Quest Log (string)
		MalVars.partyBuns, MalVars.partyRats, MalVars.partyFrogs = 0, 0, 0; 	-- how many of each the party has killed
		MalVars.emoted = 0; 													-- How many got it right
		MalVars.duelWon = 0;													-- Locally record if a player has won a duel (0 or 1)
		MalVars.duels = 0;													-- Accumulator for number of party duel victories (number)
		MalVars.sharked = 0;													-- Whether a player has been killed by shark yet (0 or 1)
		Mchoices = {};
		MarauderTracker.q1b.text:SetText(MalVars.Quests.q1b.Title .. "(0/3)"); -- for tracking bunnies
		MarauderTracker.q1c.text:SetText(MalVars.Quests.q1c.Title .. "(0/3)"); -- for tracking merchant clues
		MarauderTracker.q2f.text:SetText(MalVars.Quests.q2f.Title .. "(0/4)"); -- for tracking frogs and rats
		MarauderTracker.q3a.text:SetText(MalVars.Quests.q3a.Title .. "(0/" .. GetNumPartyMembers() .. ")"); -- for tracking duels
	end


	if chkpt >= 20 then
		--Show ring
		MarauderRing:Show();
	end

	if chkpt >= 30 then
		--the state after sound check
	end

	if chkpt >= 40 then
		--the state after whisper check
	end

	if chkpt >= 50 then
		--before the click of Cutscene 1
	end

	if chkpt >= 60 then
		--like pressing the SET button
		MalVars.currQuest = "q0a";
		MQuestFrameOKButton:Show();
		MQuestFrameBotRightPatch:Hide();
		--Tracker: Show the three quest category titles and the quest book
		MarauderBook:Show();
		MarauderTracker:Show();
		MarauderTracker.title1:Show();
		MarauderTracker.title2:Show();
		MarauderTracker.title3:Show();
	end

	if chkpt >= 70 then
		--like accepting q0a
	end

	if chkpt >= 80 then
		--state after displaying "For the Marauders" with KILL researcher button
	end

	if chkpt >= 90 then
		--like clicking the GO button, enables ring click near librarian
	end

	if chkpt >= 100 then
		--like clicking near Librarian
		MalVars.currQuest = "q1a";
		MarauderTracker.q1a.text:Show();
	else
		MarauderTracker.q1a.text:Hide();
	end

	if chkpt >= 110 then
		--like accepting q1a, enables ring click near Axechewer
		--already entered Runeweaver Square for the first time
		MalVars.rune = 1;
	end

	if chkpt >= 120 then
		--like clicking near Axechewer, completing q1a
		MarauderTracker.q1a.check:Show();
	else
		MarauderTracker.q1a.check:Hide();
	end

	if chkpt >= 130 then
		--like accepting completion of q1a, getting q1b
		MalVars.currQuest = "q1b";
		MarauderTracker.q1b.text:Show();
	else
		MarauderTracker.q1b.text:Hide();
	end

	if chkpt >= 140 then
		--enables combat tracking of bunnies and squirrels
	end

	if chkpt >= 150 then
		--completed bunnies and squirrels, completing q1b
		MarauderTracker.q1b.text:SetText(MalVars.Quests.q1b.Title .. "(3/3)");
		MarauderTracker.q1b.check:Show();
	else
		MarauderTracker.q1b.check:Hide();
	end

	if chkpt >= 160 then
		--accepting q1c
		MalVars.currQuest = "q1c";
		MarauderTracker.q1c.text:Show();
	else
		MarauderTracker.q1c.text:Hide();
	end

	if chkpt >= 170 then
		--allows ring clicking at merchants
	end

	if chkpt >= 180 then
		--got all merchant clues, q1c completed
		MarauderTracker.q1c.text:SetText(MalVars.Quests.q1c.Title .. "(3/3)");
		MarauderTracker.q1c.check:Show();
	else
		MarauderTracker.q1c.check:Hide();
	end

	if chkpt >= 190 then
		--given q1d
		MalVars.currQuest = "q1d";
		MarauderTracker.q1d.text:Show();
	else
		MarauderTracker.q1d.text:Hide();
	end

	if chkpt >= 200 then
		--accepting q1d, show voting window
		popVote();
	else
		MarauderTabs:Hide();
		MaleanteTab1:Hide();
		MaleanteTab2:Hide();
		MaleanteTab3:Hide();
		MaleanteTab4:Hide();
		MaleanteTab5:Hide();
		MaleanteTab6:Hide();
		MaleanteTab7:Hide();
		MaleanteTab8:Hide();
		MaleanteTab9:Hide();
		MaleanteTab10:Hide();
		MaleanteTab11:Hide();
		MaleanteTab12:Hide();
	end

	if chkpt >= 210 then
		--voting successful, q1d completed
		MarauderTracker.q1d.check:Show();
		clearVote();
	else
		MarauderTracker.q1d.check:Hide();
	end

	if chkpt >= 220 then
		--accepted completion of q1d, offered q1e
		MalVars.currQuest = "q1e";
		MarauderTracker.q1e.text:Show();
	else
		MarauderTracker.q1e.text:Hide();
	end

	if chkpt >= 230 then
		--q1e accepted, enables click near axechewer
	end

	if chkpt >= 240 then
		--q1e completed
		MarauderTracker.q1e.check:Show();
	else
		MarauderTracker.q1e.check:Hide();
	end

	if chkpt >= 250 then
		--accepted completion of q1e, offered q1f
		MalVars.currQuest = "q1f";
		MarauderTracker.q1f.text:Show();
	else
		MarauderTracker.q1f.text:Hide();
	end

	if chkpt >= 260 then
		--accepted q1f, enables click near rhudoh
	end

	if chkpt >= 270 then
		--q1f completed
		MarauderTracker.q1f.check:Show();
	else
		MarauderTracker.q1f.check:Hide();
	end

	if chkpt >= 280 then
		--completed q1f, offered q1g, enables bolt crafting
		MalVars.currQuest = "q1g";
		MarauderTracker.q1g.text:Show();
	else
		MarauderTracker.q1g.text:Hide();
	end

	if chkpt >= 290 then
		--completed q1g
		MarauderTracker.q1g.check:Show();
	else
		MarauderTracker.q1g.check:Hide();
	end

	if chkpt >= 300 then
		--completed q1g, offered q1h
		MalVars.currQuest = "q1h";
		MarauderTracker.q1h.text:Show();
	else
		MarauderTracker.q1h.text:Hide();
	end

	if chkpt >= 310 then
		--like clicking TRADED button, completed q1h
		--Crossed into Violet thing
		MarauderTracker.q1h.check:Show();
		MalVars.viol = 1;
	else
		MarauderTracker.q1h.check:Hide();
	end

	if chkpt >= 320 then
		--offered q1i, requested first report
		MalVars.currQuest = "q1i";
		MarauderTracker.q1i.text:Show();
	else
		MarauderTracker.q1i.text:Hide();
	end

	if chkpt >= 330 then
		--accepted q1i, time to report in chat
	end

	if chkpt >= 340 then
		--like clicking REPORT-1 button, report accepted, q1i complete
		MarauderTracker.q1i.check:Show();
		MalVars.whoClue = "El tabardo con la bobina de Tesla\n     Lo Sociedad Mec\195\161nica Ninja";
	else
		MarauderTracker.q1i.check:Hide();
	end

	if chkpt >= 350 then
		--offered q2a
		MalVars.currQuest = "q2a";
		MarauderTracker.q2a.text:Show();
	else
		MarauderTracker.q2a.text:Hide();
	end

	if chkpt >= 360 then
		--accepted q2a, head to purple parlor, allows click near calliopeia
	end

	if chkpt >= 370 then
		--like clicking BRIBED button, q2a complete
		MarauderTracker.q2a.check:Show();
	else
		MarauderTracker.q2a.check:Hide();
	end

	if chkpt >= 380 then
		--accepted completion of q2a, offered q2b
		MalVars.currQuest = "q2b";
		MarauderTracker.q2b.text:Show();
	else
		MarauderTracker.q2b.text:Hide();
	end

	if chkpt >= 390 then
		--accepted q2b, enable listener for code solution
	end

	if chkpt >= 400 then
		--solved the clue, q2b completed
		MarauderTracker.q2b.check:Show();
	else
		MarauderTracker.q2b.check:Hide();
	end

	if chkpt >= 410 then
		--accepted completion of q2b, offered q2c
		MalVars.currQuest = "q2c";
		MarauderTracker.q2c.text:Show();
	else
		MarauderTracker.q2c.text:Hide();
	end

	if chkpt >= 420 then
		--accepted q2c, enables click at Azukk
		--entered Underbelly
		MalVars.und = 1;
	end

	if chkpt >= 430 then
		--completed q2c
		MarauderTracker.q2c.check:Show();
	else
		MarauderTracker.q2c.check:Hide();
	end

	if chkpt >= 440 then
		--accepted completion of q2c, offered q2d
		MalVars.currQuest = "q2d";
		MarauderTracker.q2d.text:Show();
	else
		MarauderTracker.q2d.text:Hide();
	end

	if chkpt >= 450 then
		--accepted q2d, enables emote task
		MalVars.currQuest = "q2d";
		MarauderTracker.q2d.text:Show();
	else
		MarauderTracker.q2d.text:Hide();
	end

	if chkpt >= 460 then
		--state in which one person has done the right emote but others haven't
	end

	if chkpt >= 470 then
		--all have done the right emote, q2d completed
		MarauderTracker.q2d.check:Show();
	else
		MarauderTracker.q2d.check:Hide();
	end

	if chkpt >= 480 then
		--accepted completion of q2d, q2e offered
		MalVars.currQuest = "q2e";
		MarauderTracker.q2e.text:Show();
	else
		MarauderTracker.q2e.text:Hide();
	end

	if chkpt >= 490 then
		--accepted q2e, enables ring click by Jindall
	end

	if chkpt >= 500 then
		--q2e comnplete
		MarauderTracker.q2e.check:Show();
	else
		MarauderTracker.q2e.check:Hide();
	end

	if chkpt >= 510 then
		--presented with q2f intro
	end

	if chkpt >= 520 then
		--offered q2f
		MalVars.currQuest = "q2f";
		MarauderTracker.q2f.text:Show();
	else
		MarauderTracker.q2f.text:Hide();
	end

	if chkpt >= 530 then
		--accepted q2e, enables rat combat
	end

	if chkpt >= 540 then
		--successfully killed 2 rats and 2 frogs, q2f completed
		MarauderTracker.q2f.text:SetText(MalVars.Quests.q2f.Title .. "(4/4)");
		MarauderTracker.q2f.check:Show();
	else
		MarauderTracker.q2f.check:Hide();
	end

	if chkpt >= 550 then
		--accepted completion of q2f, offered q2g
		MalVars.currQuest = "q2g";
		MarauderTracker.q2g.text:Show();
	else
		MarauderTracker.q2g.text:Hide();
	end

	if chkpt >= 560 then
		--accepted q2g, time to report in chat
	end

	if chkpt >= 570 then
		--report 2 successfully chatted (REPORT-2 button), q2g completed
		MarauderTracker.q2g.check:Show();
		MalVars.whatClue = "Construyendo una m\195\161quina\n     para derribar a Dalaran";
	else
		MarauderTracker.q2g.check:Hide();
	end

	if chkpt >= 580 then
		--accepted completion of q2g, enables click near Apriloneil
	end

	if chkpt >= 590 then
		--clicked near Apriloneil, offered q3a
		MalVars.currQuest = "q3a";
		MarauderTracker.q3a.text:Show();
	else
		MarauderTracker.q3a.text:Hide();
	end

	if chkpt >= 600 then
		--accepted q3a, enabling dueling
	end
	if chkpt >= 610 then
		--completed all duels, q3a complete
		local total = GetNumPartyMembers();
		MarauderTracker.q3a.text:SetText(MalVars.Quests.q3a.Title .. "(" .. total .. "/" .. total .. ")");
		MarauderTracker.q3a.check:Show();
	else
		MarauderTracker.q3a.check:Hide();
	end

	if chkpt >= 620 then
		--accepted completion of q3a, offered q3b
		MalVars.currQuest = "q3b"
		MarauderTracker.q3b.text:Show();
	else
		MarauderTracker.q3b.text:Hide();
	end

	if chkpt >= 630 then
		--accepted q3b, enables first click by WUM
	end

	if chkpt >= 640 then
		--clicked near WUM, q3b complete
		MarauderTracker.q3b.check:Show();
	else
		MarauderTracker.q3b.check:Hide();
	end

	if chkpt >= 650 then
		--accepted completion of q3b, offered q3c (go die from shark)
		MalVars.currQuest = "q3c";
		MarauderTracker.q3c.text:Show();
	else
		MarauderTracker.q3c.text:Hide();
	end

	if chkpt >= 660 then
		--accpeted q3c, allows shark combat tracking
	end

	if chkpt >= 670 then
		--someone died by shark, triggering overhead message
	end

	if chkpt >= 680 then
		--q3c complete
		MarauderTracker.q3c.check:Show();
	else
		MarauderTracker.q3c.check:Hide();
	end

	if chkpt >= 690 then
		--accepted completion of q3c, enables next click at WUM
	end

	if chkpt >= 700 then
		--completed cutscene 2, offered q3d
		MalVars.currQuest = "q3d"
		MarauderTracker.q3d.text:Show();
	else
		MarauderTracker.q3d.text:Hide();
	end

	if chkpt >= 710 then
		--accepted q3d, time to report in chat
	end

	if chkpt >= 720 then
		--Like clicking REPORT-3 button, successful report in chat, q3d complete
		MarauderTracker.q3d.check:Show();
		MalVars.howClue = "La m\195\161quina usa magia par funcionar...\n     Utilicen magia para vencerla";
	else
		MarauderTracker.q3d.check:Hide();
	end

	if chkpt >= 730 then
		--accepted completion of q3d, offered q3e
		MalVars.currQuest = "q3e";
		MarauderTracker.q3e.text:Show();
	else
		MarauderTracker.q3e.text:Hide();
	end

	if chkpt >= 740 then
		--accepted q3e, allows click near Aladria on surface
	end

	if chkpt >= 750 then
		--successfully reported with click at Aladria, q3e complete
		MarauderTracker.q3e.check:Show();
	else
		MarauderTracker.q3e.check:Hide();
	end

	if chkpt >= 760 then
		--accepted completion of q3e
	end

	if chkpt >= 770 then
		--like clicking BOSS-1, overhead battle cry
	end

	if chkpt >= 780 then
		--state after overhead message "hornswaggle"
	end

	if chkpt >= 790 then
		--offered q4a (boss challenge)
		MalVars.currQuest = "q4a";
		MarauderTracker.title4:Show();
		MarauderTracker.q4a.text:Show();
	else
		MarauderTracker.q4a.text:Hide();
	end

	if chkpt >= 800 then
		--biscuit eater overhead, next is combat with level 5 toons
	end

	if chkpt >= 810 then
		--like clicking MOBS button, overhead: not over yet
	end

	if chkpt >= 820 then
		--like clicking BOOM buton, cutscene 3 has been played
	end

	if chkpt >= 830 then
		--end of cutscene triggers q4a complete
		MarauderTracker.q4a.check:Show();
	else
		MarauderTracker.q4a.check:Hide();
	end

	if chkpt >= 840 then
		--accepted q4a completion
	end

	if chkpt >= 850 then
		--researcher triggers leadership voting task
	end

	if chkpt == 860 then
		--researcher triggers The End graphic and resets
	end

	--and, finally...
	MalVars.checkpoint = chkpt;
	if MalVars.isRes == 1 then
		MarauderRes:Show();
		trace("Re-set MalVars.checkpoint to " .. chkpt .. ", MalVars.currQuest is " .. MalVars.currQuest);
	end

end


